# class KCommandHistory | The command history stores a (user) configurable amount of Commands. More...
Definition | `#include <kcommand.h>`
Inherits | QObject (qt) [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- KCommandHistory ()
- KCommandHistory (KActionCollection *actionCollection, bool withMenus = true)
- virtual ~KCommandHistory ()
- void clear ()
- void addCommand (KCommand *command, bool execute=true)
- const int & undoLimit ()
- void setUndoLimit (const int &limit)
- const int & redoLimit ()
- void setRedoLimit (const int &limit)

#### Public Slots

- virtual void undo ()
- virtual void redo ()

#### Signals

- void commandExecuted ()

#### Protected Slots

- void slotUndoAboutToShow ()
- void slotUndoActivated ( int )
- void slotRedoAboutToShow ()
- void slotRedoActivated ( int )

## Detailed Description

The command history stores a (user) configurable amount of Commands. It keeps track of its size and deletes commands if it gets too large. The user can set a maximum undo and a maximum redo limit (e.g. max. 50 undo / 30 redo commands). The KCommandHistory keeps track of the "borders" and deletes commands, if appropriate. It also activates/deactivates the undo/redo actions in the menu and changes the text according to the name of the command.

KCommandHistory () | ### KCommandHistory

Create a command history, to store commands. This constructor doesn't create actions, so you need to call undo and redo yourself.

KCommandHistory (KActionCollection *actionCollection, bool withMenus = true) | ### KCommandHistory

Create a command history, to store commands. This also creates an undo and a redo action, in the `actionCollection`, using the standard names ("edit_undo" and "edit_redo").

Parameters:

withMenus | if true, the actions will display a menu when plugged into a toolbar.

~KCommandHistory () | ### ~KCommandHistory

[virtual]

void clear () | ### clear

Erase all the undo/redo history. Use this when reloading the data, for instance, since this invalidates all the commands.

void addCommand (KCommand *command, bool execute=true) | ### addCommand

Adds a command to the history. Call this for each `command` you create. Unless you set `execute` to false, this will also execute the command. This means, most of the application's code will look like MyCommand * cmd = new MyCommand(i18n("The name"), parameters); m_historyCommand.addCommand( cmd );

const int & undoLimit () | ### undoLimit

Returns: the maximum number of items in the undo history

void setUndoLimit (const int &limit) | ### setUndoLimit

Set the maximum number of items in the undo history

const int & redoLimit () | ### redoLimit

Returns: the maximum number of items in the redo history

void setRedoLimit (const int &limit) | ### setRedoLimit

Set the maximum number of items in the redo history

void undo () | ### undo

[virtual slot]

Undo the last action. Call this if you don't use the builtin KActions.

void redo () | ### redo

[virtual slot]

Redo the last undone action. Call this if you don't use the builtin KActions.

void slotUndoAboutToShow () | ### slotUndoAboutToShow

[protected slots slot]

void slotUndoActivated ( int ) | ### slotUndoActivated

[protected slots slot]

void slotRedoAboutToShow () | ### slotRedoAboutToShow

[protected slots slot]

void slotRedoActivated ( int ) | ### slotRedoActivated

[protected slots slot]

void commandExecuted () | ### commandExecuted

[signal]

This is called every time a command is executed (whether by addCommand, undo or redo). You can use this to update the GUI, for instance.

Generated by: root@i386.ports.openbsd.org on Wed Apr 25 13:58:24 2001, using kdoc 2.0a53.